{ inkscape, stdenv, writeScript }:
stdenv.mkDerivation rec {
  pname = "inkscape-xwayland";
  inherit (inkscape) version;
  meta.description = "Inkscape but forced to run under XWayland";

  script = writeScript "inkscape-xwayland" ''
    #!/usr/bin/env bash
    export GDK_BACKEND=x11
    ${inkscape}/bin/inkscape "$@"
  '';

  buildInputs = [ inkscape ];
  dontUnpack = true; dontFixup = true;
  installPhase = ''
    mkdir -p $out/bin
    cp ${script} $out/bin/inkscape
  '';
}
